3 # Copyright (C) 2017 Luis R. Rodriguez <mcgrof@kernel.org>
5 # This program is free software; you can redistribute it and/or modify it
6 # under the terms of the GNU General Public License as published by the Free
7 # Software Foundation; either version 2 of the License, or at your option any
8 # later version; or, when distributed separately from the Linux kernel or
9 # when incorporated into other software packages, subject to the following
12 # This program is free software; you can redistribute it and/or modify it
13 # under the terms of copyleft-next (version 0.3.1 or later) as published
14 # at http://copyleft-next.org/.
16 # This is a stress test script for kmod, the kernel module loader. It uses
17 # test_kmod which exposes a series of knobs for the API for us so we can
18 # tweak each test in userspace rather than in kernelspace.
20 # The way kmod works is it uses the kernel's usermode helper API to eventually
21 # call /sbin/modprobe. It has a limit of the number of concurrent calls
22 # possible. The kernel interface to load modules is request_module(), however
23 # mount uses get_fs_type(). Both behave slightly differently, but the
24 # differences are important enough to test each call separately. For this
25 # reason test_kmod starts by providing tests for both calls.
27 # The test driver test_kmod assumes a series of defaults which you can
28 # override by exporting to your environment prior running this script.
29 # For instance this script assumes you do not have xfs loaded upon boot.
30 # If this is false, export DEFAULT_KMOD_FS="ext4" prior to running this
31 # script if the filesystem module you don't have loaded upon bootup
32 # is ext4 instead. Refer to allow_user_defaults() for a list of user
33 # override variables possible.
35 # You'll want at least 4 GiB of RAM to expect to run these tests
36 # without running out of memory on them. For other requirements refer
42 TEST_DRIVER="test_${TEST_NAME}"
43 TEST_DIR=$(dirname $0)
47 # TEST_ID:TEST_COUNT:ENABLED
49 # TEST_ID: is the test id number
50 # TEST_COUNT: number of times we should run the test
51 # ENABLED: 1 if enabled, 0 otherwise
53 # Once these are enabled please leave them as-is. Write your own test,
54 # we have tons of space.
56 ALL_TESTS="$ALL_TESTS 0002:3:1"
57 ALL_TESTS="$ALL_TESTS 0003:1:1"
58 ALL_TESTS="$ALL_TESTS 0004:1:1"
59 ALL_TESTS="$ALL_TESTS 0005:10:1"
60 ALL_TESTS="$ALL_TESTS 0006:10:1"
61 ALL_TESTS="$ALL_TESTS 0007:5:1"
62 ALL_TESTS="$ALL_TESTS 0008:150:1"
63 ALL_TESTS="$ALL_TESTS 0009:150:1"
64 ALL_TESTS="$ALL_TESTS 0010:1:1"
65 ALL_TESTS="$ALL_TESTS 0011:1:1"
66 ALL_TESTS="$ALL_TESTS 0012:1:1"
67 ALL_TESTS="$ALL_TESTS 0013:1:1"
69 # Kselftest framework requirement - SKIP code is 4.
74 if [ ! -d $DIR ]; then
75 echo "$0: $DIR not present" >&2
76 echo "You must have the following enabled in your kernel:" >&2
77 cat $TEST_DIR/config >&2
82 function allow_user_defaults()
84 if [ -z $DEFAULT_KMOD_DRIVER ]; then
85 DEFAULT_KMOD_DRIVER="test_module"
88 if [ -z $DEFAULT_KMOD_FS ]; then
92 if [ -z $PROC_DIR ]; then
93 PROC_DIR="/proc/sys/kernel/"
96 if [ -z $MODPROBE_LIMIT ]; then
101 DIR="/sys/devices/virtual/misc/${TEST_DRIVER}0/"
104 if [ -z $DEFAULT_NUM_TESTS ]; then
105 DEFAULT_NUM_TESTS=150
108 MODPROBE_LIMIT_FILE="${PROC_DIR}/kmod-limit"
113 if ! which modprobe 2> /dev/null > /dev/null; then
114 echo "$0: You need modprobe installed" >&2
118 if ! which kmod 2> /dev/null > /dev/null; then
119 echo "$0: You need kmod installed" >&2
123 # kmod 19 has a bad bug where it returns 0 when modprobe
124 # gets called *even* if the module was not loaded due to
125 # some bad heuristics. For details see:
127 # A work around is possible in-kernel but its rather
129 KMOD_VERSION=$(kmod --version | awk '{print $3}')
130 if [[ $KMOD_VERSION -le 19 ]]; then
131 echo "$0: You need at least kmod 20" >&2
132 echo "kmod <= 19 is buggy, for details see:" >&2
133 echo "https://git.kernel.org/cgit/utils/kernel/kmod/kmod.git/commit/libkmod/libkmod-module.c?id=fd44a98ae2eb5eb32161088954ab21e58e19dfc4" >&2
138 if [ $uid -ne 0 ]; then
139 echo $msg must be run as root >&2
144 function load_req_mod()
146 trap "test_modprobe" EXIT
148 if [ ! -d $DIR ]; then
149 # Alanis: "Oh isn't it ironic?"
150 modprobe $TEST_DRIVER
156 echo "$MODPROBE" > /proc/sys/kernel/modprobe
157 echo "Test completed"
163 # kmod calls modprobe and upon of a module not found
164 # modprobe returns just 1... However in the kernel we
165 # *sometimes* see 256...
186 echo MODULE_NOT_FOUND;;
201 config_set_test_case_driver()
203 if ! echo -n 1 >$DIR/config_test_case; then
204 echo "$0: Unable to set to test case to driver" >&2
209 config_set_test_case_fs()
211 if ! echo -n 2 >$DIR/config_test_case; then
212 echo "$0: Unable to set to test case to fs" >&2
219 if ! echo -n $1 >$DIR/config_num_threads; then
220 echo "$0: Unable to set to number of threads" >&2
225 config_get_modprobe_limit()
227 if [[ -f ${MODPROBE_LIMIT_FILE} ]] ; then
228 MODPROBE_LIMIT=$(cat $MODPROBE_LIMIT_FILE)
233 config_num_thread_limit_extra()
235 MODPROBE_LIMIT=$(config_get_modprobe_limit)
236 let EXTRA_LIMIT=$MODPROBE_LIMIT+$1
237 config_num_threads $EXTRA_LIMIT
240 # For special characters use printf directly,
241 # refer to kmod_test_0001
244 if ! echo -n $1 >$DIR/config_test_driver; then
245 echo "$0: Unable to set driver" >&2
252 if ! echo -n $1 >$DIR/config_test_fs; then
253 echo "$0: Unable to set driver" >&2
260 cat $DIR/config_test_driver
263 config_get_test_result()
270 if ! echo -n "1" >"$DIR"/reset; then
271 echo "$0: reset should have worked" >&2
278 echo "----------------------------------------------------"
280 echo "----------------------------------------------------"
285 if ! echo -n "1" >"$DIR"/trigger_config 2>/dev/null; then
286 echo "$1: FAIL - loading should have worked"
290 echo "$1: OK! - loading kmod test"
293 config_trigger_want_fail()
295 if echo "1" > $DIR/trigger_config 2>/dev/null; then
296 echo "$1: FAIL - test case was expected to fail"
300 echo "$1: OK! - kmod test case failed as expected"
303 config_expect_result()
305 RC=$(config_get_test_result)
306 RC_NAME=$(errno_val_to_name $RC)
309 ERRNO=$(errno_name_to_val $ERRNO_NAME)
311 if [[ $ERRNO_NAME = "-ERR_ANY" ]]; then
312 if [[ $RC -ge 0 ]]; then
313 echo "$1: FAIL, test expects $ERRNO_NAME - got $RC_NAME ($RC)" >&2
317 elif [[ $RC != $ERRNO ]]; then
318 echo "$1: FAIL, test expects $ERRNO_NAME ($ERRNO) - got $RC_NAME ($RC)" >&2
322 echo "$1: OK! - Return value: $RC ($RC_NAME), expected $ERRNO_NAME"
325 kmod_defaults_driver()
328 modprobe -r $DEFAULT_KMOD_DRIVER
329 config_set_driver $DEFAULT_KMOD_DRIVER
335 modprobe -r $DEFAULT_KMOD_FS
336 config_set_fs $DEFAULT_KMOD_FS
337 config_set_test_case_fs
340 kmod_test_0001_driver()
346 printf $NAME >"$DIR"/config_test_driver
347 config_trigger ${FUNCNAME[0]}
348 config_expect_result ${FUNCNAME[0]} MODULE_NOT_FOUND
357 printf $NAME >"$DIR"/config_test_fs
358 config_trigger ${FUNCNAME[0]}
359 config_expect_result ${FUNCNAME[0]} -EINVAL
364 kmod_test_0001_driver
368 kmod_test_0002_driver()
370 NAME="nope-$DEFAULT_KMOD_DRIVER"
373 config_set_driver $NAME
375 config_trigger ${FUNCNAME[0]}
376 config_expect_result ${FUNCNAME[0]} MODULE_NOT_FOUND
381 NAME="nope-$DEFAULT_KMOD_FS"
385 config_trigger ${FUNCNAME[0]}
386 config_expect_result ${FUNCNAME[0]} -EINVAL
391 kmod_test_0002_driver
399 config_trigger ${FUNCNAME[0]}
400 config_expect_result ${FUNCNAME[0]} SUCCESS
407 config_trigger ${FUNCNAME[0]}
408 config_expect_result ${FUNCNAME[0]} SUCCESS
414 config_trigger ${FUNCNAME[0]}
415 config_expect_result ${FUNCNAME[0]} SUCCESS
421 config_trigger ${FUNCNAME[0]}
422 config_expect_result ${FUNCNAME[0]} SUCCESS
434 MODPROBE_LIMIT=$(config_get_modprobe_limit)
435 let EXTRA=$MODPROBE_LIMIT/6
436 config_num_thread_limit_extra $EXTRA
437 config_trigger ${FUNCNAME[0]}
438 config_expect_result ${FUNCNAME[0]} SUCCESS
444 MODPROBE_LIMIT=$(config_get_modprobe_limit)
445 let EXTRA=$MODPROBE_LIMIT/4
446 config_num_thread_limit_extra $EXTRA
447 config_trigger ${FUNCNAME[0]}
448 config_expect_result ${FUNCNAME[0]} SUCCESS
455 echo "/KMOD_TEST_NONEXISTENT" > /proc/sys/kernel/modprobe
456 config_trigger ${FUNCNAME[0]}
457 config_expect_result ${FUNCNAME[0]} -ENOENT
458 echo "$MODPROBE" > /proc/sys/kernel/modprobe
465 # This causes the kernel to not even try executing modprobe. The error
466 # code is still -ENOENT like when modprobe doesn't exist, so we can't
467 # easily test for the exact difference. But this still is a useful test
468 # since there was a bug where request_module() returned 0 in this case.
469 echo > /proc/sys/kernel/modprobe
470 config_trigger ${FUNCNAME[0]}
471 config_expect_result ${FUNCNAME[0]} -ENOENT
472 echo "$MODPROBE" > /proc/sys/kernel/modprobe
475 kmod_check_visibility()
480 modprobe $DEFAULT_KMOD_DRIVER
482 local priv=$(eval $cmd)
483 local unpriv=$(capsh --drop=CAP_SYSLOG -- -c "$cmd")
485 if [ "$priv" = "$unpriv" ] || \
486 [ "${priv:0:3}" = "0x0" ] || \
487 [ "${unpriv:0:3}" != "0x0" ] ; then
488 echo "${FUNCNAME[0]}: FAIL, $name visible to unpriv: '$priv' vs '$unpriv'" >&2
491 echo "${FUNCNAME[0]}: OK!"
497 kmod_check_visibility /proc/modules \
498 "grep '^${DEFAULT_KMOD_DRIVER}\b' /proc/modules | awk '{print \$NF}'"
503 kmod_check_visibility '/sys/module/*/sections/*' \
504 "cat /sys/module/${DEFAULT_KMOD_DRIVER}/sections/.*text | head -n1"
511 echo "TEST_ID x NUM_TEST"
512 echo "TEST_ID: Test ID"
513 echo "NUM_TESTS: Number of recommended times to run the test"
515 echo "0001 x $(get_test_count 0001) - Simple test - 1 thread for empty string"
516 echo "0002 x $(get_test_count 0002) - Simple test - 1 thread for modules/filesystems that do not exist"
517 echo "0003 x $(get_test_count 0003) - Simple test - 1 thread for get_fs_type() only"
518 echo "0004 x $(get_test_count 0004) - Simple test - 2 threads for get_fs_type() only"
519 echo "0005 x $(get_test_count 0005) - multithreaded tests with default setup - request_module() only"
520 echo "0006 x $(get_test_count 0006) - multithreaded tests with default setup - get_fs_type() only"
521 echo "0007 x $(get_test_count 0007) - multithreaded tests with default setup test request_module() and get_fs_type()"
522 echo "0008 x $(get_test_count 0008) - multithreaded - push kmod_concurrent over max_modprobes for request_module()"
523 echo "0009 x $(get_test_count 0009) - multithreaded - push kmod_concurrent over max_modprobes for get_fs_type()"
524 echo "0010 x $(get_test_count 0010) - test nonexistent modprobe path"
525 echo "0011 x $(get_test_count 0011) - test completely disabling module autoloading"
526 echo "0012 x $(get_test_count 0012) - test /proc/modules address visibility under CAP_SYSLOG"
527 echo "0013 x $(get_test_count 0013) - test /sys/module/*/sections/* visibility under CAP_SYSLOG"
532 NUM_TESTS=$(grep -o ' ' <<<"$ALL_TESTS" | grep -c .)
533 let NUM_TESTS=$NUM_TESTS+1
534 MAX_TEST=$(printf "%04d\n" $NUM_TESTS)
535 echo "Usage: $0 [ -t <4-number-digit> ] | [ -w <4-number-digit> ] |"
536 echo " [ -s <4-number-digit> ] | [ -c <4-number-digit> <test- count>"
537 echo " [ all ] [ -h | --help ] [ -l ]"
539 echo "Valid tests: 0001-$MAX_TEST"
541 echo " all Runs all tests (default)"
542 echo " -t Run test ID the number amount of times is recommended"
543 echo " -w Watch test ID run until it runs into an error"
544 echo " -s Run test ID once"
545 echo " -c Run test ID x test-count number of times"
546 echo " -l List all test ID list"
547 echo " -h|--help Help"
549 echo "If an error every occurs execution will immediately terminate."
550 echo "If you are adding a new test try using -w <test-ID> first to"
551 echo "make sure the test passes a series of tests."
555 echo "${TEST_NAME}.sh -- executes all tests"
556 echo "${TEST_NAME}.sh -t 0008 -- Executes test ID 0008 number of times is recommended"
557 echo "${TEST_NAME}.sh -w 0008 -- Watch test ID 0008 run until an error occurs"
558 echo "${TEST_NAME}.sh -s 0008 -- Run test ID 0008 once"
559 echo "${TEST_NAME}.sh -c 0008 3 -- Run test ID 0008 three times"
568 if ! [[ $1 =~ $re ]]; then
573 function get_test_data()
576 local field_num=$(echo $1 | sed 's/^0*//')
577 echo $ALL_TESTS | awk '{print $'$field_num'}'
580 function get_test_count()
582 TEST_DATA=$(get_test_data $1)
583 LAST_TWO=${TEST_DATA#*:*}
587 function get_test_enabled()
589 TEST_DATA=$(get_test_data $1)
590 echo ${TEST_DATA#*:*:}
593 function run_all_tests()
595 for i in $ALL_TESTS ; do
597 ENABLED=$(get_test_enabled $TEST_ID)
598 TEST_COUNT=$(get_test_count $TEST_ID)
599 if [[ $ENABLED -eq "1" ]]; then
600 test_case $TEST_ID $TEST_COUNT
607 if [ $# -ne 3 ]; then
611 echo "Running test: $2 - run #$1"
614 function watch_case()
619 if [ $# -eq 1 ]; then
621 watch_log $i ${TEST_NAME}_test_$1
633 NUM_TESTS=$DEFAULT_NUM_TESTS
634 if [ $# -eq 2 ]; then
639 while [ $i -lt $NUM_TESTS ]; do
641 watch_log $i ${TEST_NAME}_test_$1 noclear
642 RUN_TEST=${TEST_NAME}_test_$1
648 function parse_args()
650 if [ $# -eq 0 ]; then
653 if [[ "$1" = "all" ]]; then
655 elif [[ "$1" = "-w" ]]; then
658 elif [[ "$1" = "-t" ]]; then
661 test_case $1 $(get_test_count $1)
662 elif [[ "$1" = "-c" ]]; then
667 elif [[ "$1" = "-s" ]]; then
670 elif [[ "$1" = "-l" ]]; then
672 elif [[ "$1" = "-h" || "$1" = "--help" ]]; then
684 MODPROBE=$(</proc/sys/kernel/modprobe)
685 trap "test_finish" EXIT